#ifndef MIDI_HPP
#define MIDI_HPP

namespace MIDI
{

struct HEADER_CHUNK {
	char	type[4];
	int		length;
	short	format;
	short	track;
	short	time;
} __attribute((packed));

struct TRACK_CHUNK {
	char	type[4];
	int		length;
	char	data[];
};

// Event Message definition
enum EVENT {
	NOTE_OFF		= 0x80,
	NOTE_ON			= 0x90,
	POLYKEY_PRESS	= 0xA0,
	CC				= 0xB0,
	PC				= 0xC0,
	CHANNEL_PRESS	= 0xD0,
	PITCHBEND		= 0xE0,
	SYS_EX			= 0xF0,
	SYS_EX_PART		= 0xF7,
	META			= 0xFF,
};

// CC Number definition
enum CC {
	BANK_MSB			= 0x00,
	BANK_LSB			= 0x20,

	DATAENTRY_MSB		= 0x06,
	RPN_LSB				= 0x64,
	RPN_MSB				= 0x65,

	MODULATION			= 0x01,
	PORTAMENT_TIME		= 0x05,
	VOLUME				= 0x07,
	PANPOT				= 0x0A,
	EXPRESSION			= 0x0B,

	MODULATION_LSB		= 0x21,
	PORTAMENT_TIME_LSB	= 0x25,
	DATAENTRY_LSB		= 0x26,
	VOLUME_LSB			= 0x27,
	PANPOT_LSB			= 0x2A,
	EXPRESSION_LSB		= 0x2B,

	VOICE_RESERVE		= 0x37, // CC#55
	LOOP_POINT			= 0x38, // CC#56

	HOLD				= 0x40,
	PORTAMENT			= 0x41,
	LEGATO				= 0x44,
	BRIGHTNESS			= 0x4A,
	MONO				= 0x7E,
	POLY				= 0x7F,
};

}
#endif
