#ifndef MIDIC_HPP
#define MIDIC_HPP
#include <vector>
#include "midid.hpp"

namespace MIDI
{
class MIDIC {

private:
	static const unsigned int CONVERTION_TPQN = 480;
	static const unsigned int CONVERTION_FPS = 60;
	unsigned int convertion_tpqn;
	struct Event;
	DMIDI* dmidi;

	void dmid_append(const unsigned int clock, const int mes, const int lsb, const int msb );
	unsigned char* parse_deltatime(unsigned char* p, Event* event);
	unsigned char* parse_event(unsigned char* p, Event* event);

public:
	DMIDI* convert_smf(char* smf_data, unsigned int tpqn = CONVERTION_TPQN);
	DMIDI* convert_clock_to_frame(DMIDI* dmidi_data, unsigned int fps = CONVERTION_FPS);
};

}
#endif
