#ifndef MMLGEN_H
#define MMLGEN_H

#include "midid.hpp"

namespace MIDI
{
struct Status
{
	Status() : 
		finished(false),
		have_note(false),
		track(0),
		last_clock(0),
		last_note_clock(0),
		last_note(0xff),
		vel(0xff),
		last_vel(0xff),
		oct_base(0xff),
		note_on(false),
		note_printed(false),
		tied(false),
		tie_remain(false),
		module_type_out(false),
		beg(std::vector<DMIDI_EVENT>::iterator(0))
		{}

	bool finished;
	bool have_note;
	int track;
	unsigned int clock;
	unsigned int last_clock;
	unsigned int last_note_clock;
	unsigned int last_note;
	unsigned int vel;
	unsigned int last_vel;
	int oct_base;
	bool note_on;
	bool note_printed;
	bool tied;
	bool tie_remain;
	bool module_type_out;

	std::vector<DMIDI_EVENT>::iterator beg;
};

bool mmlgen(std::ostringstream& str, DMIDI* dm, Status& sta);

} // namespace MIDI

#endif /* MMLGEN_H */
